### Contributing to PC-BASIC ###

Thanks for your interest in contributing to PC-BASIC!


#### Bug reports ####

If you find bugs, please [open an issue on GitHub](https://github.com/robhagemans/pcbasic/issues).

In your bug report, please specify:

- What version of PC-BASIC you're using;
- What operating system you're using, including the version and whether it's 64-bit or 32-bit;
- What you did;
- What you expected to happen;
- What happened instead.

The very best thing to do in a bug report is to post a little BASIC program that triggers the bug or the unwanted behaviour.
That often enables me to see what's going on right away, and if not I can try it for myself. It's almost magic like that.

After you post your report, please check back in the next few days: often, it's not obvious to me from the first report what the exact problem is, since people use different setups, have different expectations and make different assumptions. I'll usually reply fairly quickly to ask you for some more information.


#### Contributing code ####

The current code base of PC-BASIC was written by a single author, Rob Hagemans.
That is not to say it should stay that way. If you would like to contribute
code to PC-BASIC, please contact the author at _robhagemans@users.sourceforge.net_.

You'll need to agree for your code contributions to be licensed under the [Expat MIT License](https://opensource.org/licenses/MIT).
This is a more permissive licence than PC-BASIC is (currently) released under. The reason I ask for
a permissive licence for contributions is that it allows me to re-license the code at a later date.
